#version 430 core

layout (points) in;
layout (triangle_strip) out;
layout (max_vertices = 4) out;

uniform mat4 viewProjMatrix;
uniform vec3 camera_world;

out vec2 texCoords;

void main()
{ 
    float particleSize = 0.15f;
    vec3 pos = gl_in[0].gl_Position.xyz;
    vec3 toCamera = normalize(camera_world - pos);
    vec3 up = vec3(0.0, 1.0, 0.0);
    vec3 right = cross(toCamera, up);

    pos -= (right * particleSize/2.0f);
    pos.y -= particleSize/2.0f;
    gl_Position = viewProjMatrix * vec4(pos, 1.0);
    texCoords = vec2(0.0, 0.0);
    EmitVertex();

    pos.y += particleSize;
    gl_Position = viewProjMatrix * vec4(pos, 1.0);
    texCoords = vec2(0.0, 1.0);
    EmitVertex();

    pos.y -= particleSize;
    pos += right * particleSize;
    gl_Position = viewProjMatrix * vec4(pos, 1.0);
    texCoords = vec2(1.0, 0.0);
    EmitVertex();

    pos.y += particleSize;
    gl_Position = viewProjMatrix * vec4(pos, 1.0);
    texCoords = vec2(1.0, 1.0);
    EmitVertex();

    EndPrimitive();
}