#version 430 core

out vec4 color;
in vec2 texCoords;

uniform sampler2D quadTexture;
uniform sampler2D bloomBlur;

uniform float exposure;


void main()
{             
    const float gamma = 1.0;
    vec3 hdrColor = texture(quadTexture, texCoords).rgb;      
    vec3 bloomColor = texture(bloomBlur, texCoords).rgb;
    hdrColor += bloomColor; // additive blending
    // tone mapping
    //vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
    // also gamma correct while we're at it       
    //result = pow(result, vec3(1.0 / gamma));
    color = vec4(hdrColor * exposure, 1.0);
}