#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

in VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
	vec2 uv2;
	mat3 TBN;
} vert;

layout (location = 0) out vec4 color;
layout (location = 1) out vec4 brightColor;


uniform vec3 matColor;

uniform bool hasTexture;
uniform sampler2D matTexture;


uniform vec3 camera_world;


void main() {	
	
	color = vec4(hasTexture ? texture(matTexture, vert.uv).rgb : matColor, 1);

	float brightness = dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
	if(brightness > 0.8)
        brightColor = vec4(color.rgb, 1.0);
    else
        brightColor = vec4(0.0, 0.0, 0.0, 1.0);
		brightColor.rgb += camera_world * 0.000000001; //this is just so the uniform camera_world doesn't get deleted
		brightColor.rgb += vert.normal_world * 0.000000001;
}

