#version 430 core

in vec3 texCoords;

layout (location = 0) out vec4 fragColor;
layout (location = 1) out vec4 brightColor;

uniform samplerCube skybox;

uniform float brightnessFactor = 1.0f;
uniform float ambient = 1.0f;

uniform float bloomThreshold = 0.8f;

void main()
{    
    fragColor = texture(skybox, texCoords) * ambient;   // * brightness;

    float brightness = dot(fragColor.rgb, vec3(0.2126, 0.7152, 0.0722));
    brightColor = (brightness > bloomThreshold) ? vec4(fragColor.rgb, 1.0) : vec4(0.0, 0.0, 0.0, 1.0);
}